package java.io;

class Bits
{
    Bits() {
    }
    
    static boolean getBoolean(byte[] array, int n) {
        return array[n] != 0;
    }
    
    static char getChar(byte[] array, int n) {
        return (char)((array[n + 1] & 0xFF) + (array[n] << 8));
    }
    
    static short getShort(byte[] array, int n) {
        return (short)((array[n + 1] & 0xFF) + (array[n] << 8));
    }
    
    static int getInt(byte[] array, int n) {
        return (array[n + 3] & 0xFF) + ((array[n + 2] & 0xFF) << 8) + ((array[n + 1] & 0xFF) << 16) + (array[n] << 24);
    }
    
    static float getFloat(byte[] array, int n) {
        return Float.intBitsToFloat(getInt(array, n));
    }
    
    static long getLong(byte[] array, int n) {
        return ((long)array[n + 7] & 0xFFL) + (((long)array[n + 6] & 0xFFL) << 8) + (((long)array[n + 5] & 0xFFL) << 16) + (((long)array[n + 4] & 0xFFL) << 24) + (((long)array[n + 3] & 0xFFL) << 32) + (((long)array[n + 2] & 0xFFL) << 40) + (((long)array[n + 1] & 0xFFL) << 48) + ((long)array[n] << 56);
    }
    
    static double getDouble(byte[] array, int n) {
        return Double.longBitsToDouble(getLong(array, n));
    }
    
    static void putBoolean(byte[] array, int n, boolean b) {
        array[n] = (b ? ((byte)1) : ((byte)0));
    }
    
    static void putChar(byte[] array, int n, char c) {
        array[n + 1] = (byte)c;
        array[n] = (byte)(c >>> 8);
    }
    
    static void putShort(byte[] array, int n, short n2) {
        array[n + 1] = (byte)n2;
        array[n] = (byte)(n2 >>> 8);
    }
    
    static void putInt(byte[] array, int n, int n2) {
        array[n + 3] = (byte)n2;
        array[n + 2] = (byte)(n2 >>> 8);
        array[n + 1] = (byte)(n2 >>> 16);
        array[n] = (byte)(n2 >>> 24);
    }
    
    static void putFloat(byte[] array, int n, float value) {
        putInt(array, n, Float.floatToIntBits(value));
    }
    
    static void putLong(byte[] array, int n, long n2) {
        array[n + 7] = (byte)(int)n2;
        array[n + 6] = (byte)(int)(n2 >>> 8);
        array[n + 5] = (byte)(int)(n2 >>> 16);
        array[n + 4] = (byte)(int)(n2 >>> 24);
        array[n + 3] = (byte)(int)(n2 >>> 32);
        array[n + 2] = (byte)(int)(n2 >>> 40);
        array[n + 1] = (byte)(int)(n2 >>> 48);
        array[n] = (byte)(int)(n2 >>> 56);
    }
    
    static void putDouble(byte[] array, int n, double value) {
        putLong(array, n, Double.doubleToLongBits(value));
    }
}
